--------------------------------------------------------------------------------
-- Parts of the code is inspired or taken from the following AddOns...
--  - MozzFullWorldMap (http://www.wowinterface.com/downloads/fileinfo.php?s=&id=4046)
--
-- Version history...
--  0.1.0 - Windowed WorlMap with standard navigation
--  0.1.1 - Player and Cursor position
--        - Ping-Marker for the Player for better visibility
--  0.1.2 - Display of undiscovered areas in an different collor
--  0.1.3 - Colored unitpins for player, party, raid
--        - *FIX* showing unitpin-tooltip
--        - Classcolored names in unitpin-tooltip
--        - Showing unit level in unitpin-tooltip
--        - Integrated FWM code
--        - Key binding
--------------------------------------------------------------------------------


-- Debug mode (true=on, nil=off)
local DEBUG_MODE = true;

-- Version of the data structure in the saved vars
AOAWMAP_DATA_VERSION = 1;
AOAWMAP_DATA_COMPATIBILITY = 1;

-- Flags of the init routines
local AoAWMap_Initialized = false;
local AoAWMap_ADDON_LOADED = false;
local AoAWMap_VARIABLES_LOADED = false;
local AoAWMap_TabID = nil;

-- some constants, status vars
local WORLDMAP_DETAIL_TILES = 12;
local WORLDMAP_DETAIL_TEXTURE_SIZE = 169;
local WORLDMAP_DETAIL_SCALE = WORLDMAP_DETAIL_TEXTURE_SIZE / 256;
local WORLDMAP_OVERLAYS = 0;
local WORLDMAP_FLAGS = 2;
local WORLDMAP_POIS = 0;
local WORLDMAP_POI_COLUMNS = 8;
local WORLDMAP_POI_TEXTURE_WIDTH = 128;

local FullMapOverlayInfo = {
["Teldrassil"] = { "RUTTHERANVILLAGE:128:100:494:548","STARBREEZEVILLAGE:200:200:561:292",
  "GNARLPINEHOLD:185:128:368:443","LAKEALAMETH:256:185:436:380","WELLSPRINGLAKE:180:256:377:93",
  "THEORACLEGLADE:170:240:272:127","BANETHILHOLLOW:160:210:382:281","DOLANAAR:190:128:462:323",
  "SHADOWGLEN:225:225:491:153","POOLSOFARLITHRIEN:128:190:335:313","DARNASSUS:315:256:101:247",
},["DunMorogh"] = { "AMBERSTILLRANCH:128:128:573:280","FROSTMANEHOLD:125:125:217:287",
  "ICEFLOWLAKE:128:180:281:167","THEGRIZZLEDDEN:200:185:314:311","HELMSBEDLAKE:155:170:694:273",
  "SHIMMERRIDGE:128:190:347:163","CHILLBREEZEVALLEY:180:128:274:296","ANVILMAR:240:185:155:403",
  "MISTYPINEREFUGE:128:165:502:221","GOLBOLARQUARRY:165:165:608:291","KHARANOS:200:200:386:294",
  "THETUNDRIDHILLS:155:128:522:322","IRONFORGE:315:200:397:163","COLDRIDGEPASS:150:128:295:385",
  "NORTHERNGATEOUTPOST:128:165:759:173","SOUTHERNGATEOUTPOST:128:120:792:279",
  "GNOMERAGON:180:165:166:184","BREWNALLVILLAGE:115:115:252:249",
},["Elwynn"] = { "EASTVALELOGGINGCAMP:256:210:704:330","BRACKWELLPUMPKINPATCH:256:249:577:419",
  "FORESTSEDGE:256:341:124:327","FARGODEEPMINE:256:240:238:428","JERODSLANDING:256:237:425:431",
  "STORMWIND:485:405:0:0","GOLDSHIRE:240:220:250:270","TOWEROFAZORA:255:250:551:292",
  "CRYSTALLAKE:225:220:422:332","RIDGEPOINTTOWER:306:233:696:435",
  "STONECAIRNLAKE:310:256:587:190","NORTHSHIREVALLEY:256:256:381:147",
},["Mulgore"] = { "WINTERHOOFWATERWELL:170:128:458:369","THUNDERHORNWATERWELL:128:155:379:242",
  "RAVAGEDCARAVAN:128:120:473:260","PALEMANEROCK:128:205:303:307","WINDFURYRIDGE:205:128:395:0",
  "REDCLOUDMESA:470:243:270:425","THUNDERBLUFF:280:240:249:59","BAELDUNDIGSITE:210:180:255:214",
  "WILDMANEWATERWELL:185:128:291:0","THEGOLDENPLAINS:215:240:428:80","REDROCKS:205:230:502:16",
  "BLOODHOOFVILLAGE:256:200:367:303","THEROLLINGPLAINS:256:190:523:356",
  "THEVENTURECOMINE:225:235:532:238",
},["Tirisfal"] = { "SCARLETWATCHPOST:175:247:689:104","SOLLIDENFARMSTEAD:256:156:239:250",
  "GARRENSHAUNT:174:220:497:145","VENOMWEBVALE:237:214:757:205","NIGHTMAREVALE:243:199:363:349",
  "AGAMANDMILLS:256:210:335:139","CRUSADEROUTPOST:173:128:694:289","DEATHKNELL:245:205:227:328",
  "BALNIRFARMSTEAD:216:179:630:326","BRIGHTWATERLAKE:201:288:587:139","BULWARK:230:205:698:362",
  "RUINSOFLORDAERON:315:235:463:361","COLDHEARTHMANOR:150:128:474:327","BRILL:128:158:537:299",
  "MONASTARY:211:189:746:125","STILLWATERPOND:186:128:395:277",
},["Durotar"] = { "RAZORMANEGROUNDS:230:230:301:189","VALLEYOFTRIALS:215:215:355:320",
  "SKULLROCK:128:110:464:33","DRYGULCHRAVINE:210:160:427:78","THUNDERRIDGE:190:200:327:60",
  "ORGRIMMAR:445:160:244:0","SENJINVILLAGE:160:190:474:384","TIRAGARDEKEEP:190:180:462:286",
  "ECHOISLES:200:240:549:427","RAZORHILL:220:230:432:170","KOLKARCRAG:160:120:413:476",
},["Westfall"] = { "WESTFALLLIGHTHOUSE:280:190:205:467","FURLBROWSPUMPKINFARM:210:215:387:11",
  "JANGOLODEMINE:215:215:307:29","SALDEANSFARM:225:210:459:105","THEDUSTPLAINS:288:235:523:377",
  "SENTINELHILL:195:240:442:241","DEMONTSPLACE:200:185:208:375","THEMOLSENFARM:225:205:328:148",
  "THEDEADACRE:200:240:524:252","THEJANSENSTEAD:165:200:488:0","THEDAGGERHILLS:256:175:339:418",
  "GOLDCOASTQUARRY:225:256:220:102","ALEXSTONFARMSTEAD:305:210:204:260",
  "MOONBROOK:220:200:317:331",
},["Silverpine"] = { "THEDECREPITFERRY:180:185:457:144","FENRISISLE:250:215:593:74",
  "THEDEADFIELD:175:165:402:65","MALDENSORCHARD:256:160:465:0","OLSENSFARTHING:165:185:382:252",
  "DEEPELEMMINE:160:170:470:261","SHADOWFANGKEEP:220:160:364:359","BERENSPERIL:240:180:491:417",
  "THESEPULCHER:210:160:352:168","PYREWOODVILLAGE:140:125:391:446","AMBERMILL:240:240:494:262",
  "THESKITTERINGDARK:185:165:286:37","NORTHTIDESHOLLOW:180:128:323:128",
  "THEGREYMANEWALL:210:215:379:447","THESHININGSTRAND:256:220:459:13",
},["LochModan"] = { "SILVERSTREAMMINE:235:270:229:11","MOGROSHSTRONGHOLD:315:235:542:48",
  "STONESPLINTERVALLEY:255:285:215:348","IRONBANDSEXCAVATIONSITE:345:256:482:321",
  "VALLEYOFKINGS:195:250:109:370","GRIZZLEPAWRIDGE:295:358:309:310","THELSAMAR:256:230:217:203",
  "THELOCH:320:410:352:87","NORTHGATEPASS:230:300:125:12","STONEWROUGHTDAM:290:175:339:11",
  "THEFARSTRIDERLODGE:370:295:546:199",
},["Darkshore"] = { "RUINSOFMATHYSTRA:195:215:510:0","TOWEROFALTHALAXX:170:195:468:85",
  "GROVEOFTHEANCIENTS:200:170:305:412","BASHALARAN:180:195:365:181","AMETHARAN:190:205:324:306",
  "THEMASTERSGLAIVE:175:158:329:510","REMTRAVELSEXCAVATION:175:183:229:485",
  "AUBERDINE:150:215:318:162","CLIFFSPRINGRIVER:230:190:375:94",
},["Redridge"] = { "STONEWATCH:255:300:500:215","GALARDELLVALLEY:250:250:654:161",
  "ALTHERSMILL:235:270:399:129","RENDERSVALLEY:465:255:484:361","LAKEEVERSTILL:535:275:133:240",
  "REDRIDGECANYONS:365:245:121:72","STONEWATCHFALLS:320:210:595:320","LAKESHIRE:340:195:83:197",
  "RENDERSCAMP:275:256:277:0","THREECORNERS:365:350:0:284","LAKERIDGEHIGHWAY:430:290:187:333",
},["Wetlands"] = { "ANGERFANGENCAMPMENT:225:185:347:218","DUNMODR:205:180:401:21",
  "SUNDOWNMARSH:300:240:92:82","THELGANROCK:230:190:470:371","BLACKCHANNELMARSH:240:175:77:245",
  "BLUEGILLMARSH:225:190:89:142","MOSSHIDEFEN:205:245:527:264","IRONBEARDSTOMB:200:185:349:115",
  "THEGREENBELT:185:240:456:125","SALTSPRAYGLEN:200:240:237:41","MENETHILHARBOR:175:128:13:314",
  "GRIMBATOL:350:360:611:230","RAPTORRIDGE:190:160:628:176","DIREFORGEHILL:256:250:507:115",
  "WHELGARSEXCAVATIONSITE:195:185:247:205",
},["Hilsbrad"] = { "DARROWHILL:205:155:414:154","NETHANDERSTEAD:215:240:541:236",
  "DURNHOLDEKEEP:384:365:605:75","SOUTHSHORE:235:270:418:201","HILLSBRADFIELDS:305:275:198:155",
  "TARRENMILL:220:310:509:0","AZURELOADMINE:165:200:175:275","SOUTHPOINTTOWER:288:225:2:192",
  "DUNGAROK:240:275:637:294","EASTERNSTRAND:230:320:524:339","WESTERNSTRAND:285:155:208:368",
  "PURGATIONISLE:125:100:109:482",
},["Duskwood"] = { "THEYORGENFARMSTEAD:235:250:390:382","THEROTTINGORCHARD:250:230:539:369",
  "VULGOLOGREMOUND:255:285:243:348","TWILIGHTGROVE:360:420:298:79","ADDLESSTEAD:275:250:55:342",
  "MANORMISTMANTLE:200:175:653:120","THEDARKENEDBANK:910:210:89:31","RAVENHILL:195:145:102:302",
  "THEHUSHEDBANK:160:330:19:132","DARKSHIRE:315:280:631:162","BRIGHTWOODGROVE:220:340:504:117",
  "TRANQUILGARDENSCEMETARY:220:220:690:353","RAVENHILLCEMETARY:350:300:85:149",
},["Alterac"] = { "LORDAMEREINTERNMENTCAMP:330:265:44:403","DANDREDSFOLD:285:230:276:0",
  "MISTYSHORE:220:280:196:131","CHILLWINDPOINT:350:370:626:253","GALLOWSCORNER:200:200:406:279",
  "CORRAHNSDAGGER:195:288:399:380","CRUSHRIDGEHOLD:280:240:334:162","THEUPLANDS:235:200:462:77",
  "GAVINSNAZE:160:175:225:478","GROWLESSCAVE:190:170:317:372","RUINSOFALTERAC:255:255:270:197",
  "STRAHNBRAD:370:300:549:105","THEHEADLAND:165:197:314:471","SOFERASNAZE:255:320:462:307",
  "DALARAN:300:300:26:262",
},["Barrens"] = { "THEFORGOTTENPOOLS:120:125:384:115","THESTAGNANTOASIS:155:128:481:211",
  "THEMORSHANRAMPART:128:100:412:0","DREADMISTPEAK:128:105:419:63","THEDRYHILLS:200:145:317:29",
  "BOULDERLODEMINE:120:110:555:0","THESLUDGEFEN:170:120:456:0","THECROSSROADS:155:155:431:118",
  "NORTHWATCHFOLD:150:120:527:307","RAPTORGROUNDS:115:110:507:294","THORNHILL:140:128:498:119",
  "THEMERCHANTCOAST:95:100:581:247","LUSHWATEROASIS:175:185:365:177","RATCHET:125:125:556:189",
  "HONORSSTAND:128:128:306:130","BRAMBLESCAR:125:165:442:298","BLACKTHORNRIDGE:155:128:335:462",
  "BAELMODAN:128:128:431:479","RAZORFENKRAUL:128:128:341:537","RAZORFENDOWNS:155:115:407:553",
  "CAMPTAURAJO:145:125:365:350","GROLDOMFARM:125:115:492:63","FARWATCHPOST:100:165:564:52",
  "AGAMAGOR:200:185:340:234","FIELDOFGIANTS:210:150:355:402",
},["Stranglethorn"] = { "NESINGWARYSEXPEDITION:140:110:269:26","RUINSOFJUBUWAL:110:110:306:301",
  "ZIATAJAIRUINS:128:125:364:231","BOOTYBAY:145:128:203:433","NEKMANIWELLSPRING:90:115:211:359",
  "RUINSOFABORAZ:95:95:350:335","CRYSTALVEINMINE:120:120:345:276","MIZJAHRUINS:105:110:311:131",
  "WILDSHORE:165:190:229:422","BLOODSAILCOMPOUND:165:175:194:284","JAGUEROISLE:125:120:314:493",
  "GROMGOLBASECAMP:110:105:260:132","MOSHOGGOGREMOUND:128:175:432:94","KALAIRUINS:95:95:299:88",
  "RUINSOFZULMAMWE:170:125:394:212","MISTVALEVALLEY:125:125:280:368","THEARENA:200:185:235:189",
  "ZUULDAIARUINS:115:115:156:42","BALIAMAHRUINS:110:140:371:129","LAKENAZFERITI:128:125:331:59",
  "KURZENSCOMPOUND:155:150:388:0","RUINSOFZULKUNDA:125:140:196:3","ZULGURUB:245:220:483:8",
  "THEVILEREEF:190:175:152:90","VENTURECOBASECAMP:105:125:387:64",
  "BALALRUINS:90:80:241:92","REBELCAMP:170:90:284:0",
},["SwampOfSorrows"] = { "SPLINTERSPEARJUNCTION:275:240:129:236","THEHARBORAGE:235:205:171:145",
  "FALLOWSANCTUARY:365:305:492:0","MISTYREEDSTRAND:256:668:746:0","POOLOFTEARS:300:275:565:218",
  "THESHIFTINGMIRE:315:235:286:110","MISTYVALLEY:245:305:0:140","ITHARIUSSCAVE:240:245:0:262",
  "STONARD:360:315:279:237","STAGALBOG:345:250:552:378","SORROWMURK:215:365:724:120",
},["Arathi"] = { "CIRCLEOFINNERBINDING:210:185:286:310","CIRCLEOFOUTERBINDING:170:155:419:293",
  "NORTHFOLDMANOR:230:240:192:90","BOULDERGOR:245:245:232:145","STROMGARDEKEEP:240:230:108:287",
  "FALDIRSCOVE:256:215:171:424","THANDOLSPAN:200:220:355:412","BOULDERFISTHALL:215:235:432:362",
  "GOSHEKFARM:230:195:531:276","HAMMERFALL:205:250:655:120","WITHERBARKVILLAGE:215:210:559:333",
  "DABYRIESFARMSTEAD:180:210:472:165","CIRCLEOFEASTBINDING:160:230:558:112",
  "REFUGEPOINT:175:225:370:186","THORADINSWALL:190:240:87:138",
  "CIRCLEOFWESTBINDING:190:210:138:54",
},["Badlands"] = { "CAMPCAGG:255:220:12:428","KARGATH:240:255:0:148","CAMPKOSH:220:220:551:48",
  "LETHLORRAVINE:370:455:611:110","APOCRYPHANSREST:255:205:17:310","AGMONDSEND:265:270:345:389",
  "CAMPBOFF:255:280:501:341","THEDUSTBOWL:270:275:159:199","HAMMERTOESDIGSITE:200:195:445:120",
  "VALLEYOFFANGS:230:230:349:256","ANGORFORTRESS:195:200:325:148","MIRAGEFLATS:285:240:148:384",
  "DUSTWINDGULCH:245:205:498:209","THEMAKERSTERRACE:245:205:389:7",
},["Hinterlands"] = { "JINTHAALOR:235:285:505:333","THEOVERLOOKCLIFFS:170:310:693:303",
  "AERIEPEAK:255:205:13:245","PLAGUEMISTRAVINE:145:220:158:149","THEALTAROFZUL:200:165:373:365",
  "HIRIWATHA:225:200:171:306","QUELDANILLODGE:185:195:237:185","VALORWINDLAKE:170:170:319:302",
  "SHADRAALOR:195:185:240:387","AGOLWATHA:205:195:374:164","THECREEPINGRUIN:180:170:408:260",
  "SERADANE:275:275:509:19","SKULKROCK:160:145:512:232","SHAOLWATHA:280:205:571:239",
},["UngoroCrater"] = { "GOLAKKAHOTSPRINGS:315:345:121:151","THESLITHERINGSCAR:345:285:367:380",
  "FIREPLUMERIDGE:295:270:367:178","TERRORRUN:345:285:158:368","THEMARSHLANDS:310:355:560:240",
  "IRONSTONEPLATEAU:285:285:582:67","LAKKARITARPITS:570:265:160:6",
},["Tanaris"] = { "THISTLESHRUBVALLEY:185:250:203:286","VALLEYOFTHEWATCHERS:150:160:291:434",
  "LANDSENDBEACH:205:157:445:511","ABYSSALSANDS:215:180:363:194","ZALASHJISDEN:110:140:611:147",
  "CAVERNSOFTIME:155:150:561:256","EASTMOONRUINS:160:150:395:346","GADGETZAN:175:165:421:91",
  "BROKENPILLAR:110:180:473:234","SOUTHMOONRUINS:195:210:323:359","ZULFARRAK:210:175:254:0",
  "THEGAPINGCHASM:220:210:449:372","SOUTHBREAKSHORE:215:175:499:293",
  "DUNEMAULCOMPOUND:205:145:325:289","THENOXIOUSLAIR:180:200:252:199",
  "WATERSPRINGFIELD:165:180:509:168","LOSTRIGGERCOVE:160:190:629:220",
  "STEAMWHEEDLEPORT:155:150:592:75","NOONSHADERUINS:120:135:533:104",
  "SANDSORROWWATCH:195:175:299:100",
},["Dustwallow"] = { "THEWYRMBOG:285:240:367:381","ALCAZISLAND:200:195:660:21",
  "THERAMOREISLE:230:205:534:224","WITCHHILL:250:315:422:0","BRACKENWALLVILLAGE:280:270:230:0",
  "BACKBAYWETLANDS:400:255:239:189","THEDENOFFLAME:255:250:257:313",
},["ThousandNeedles"] = { "THEGREATLIFT:210:180:205:70","DARKCLOUDPINNACLE:205:195:259:131",
  "THESHIMMERINGFLATS:320:365:610:300","SPLITHOOFCRAG:210:195:391:192","CAMPETHOK:305:310:0:0",
  "WINDBREAKCANYON:240:220:492:250","FREEWINDPOST:210:190:357:264","HIGHPERCH:190:190:31:155",
  "THESCREECHINGCANYON:250:240:179:200",
},["SearingGorge"] = { "GRIMSILTDIGSITE:305:220:494:300",
  "THESEAOFCINDERS:360:280:247:388","TANNERCAMP:305:230:545:407","DUSTFIREVALLEY:460:365:422:8",
  "FIREWATCHRIDGE:405:430:85:30","THECAULDRON:425:325:250:170","BLACKCHARCAVE:275:235:77:366",
},["Ashenvale"] = { "THISTLEFURVILLAGE:255:195:203:158","THESHRINEOFAESSINA:220:195:104:259",
  "THEZORAMSTRAND:245:245:19:28","LAKEFALATHIM:128:195:131:137","MAESTRASPOST:215:305:205:38",
  "ASTRANAAR:205:185:272:251","IRISLAKE:200:205:392:218","THERUINSOFSTARDUST:155:150:260:373",
  "FIRESCARSHRINE:165:175:189:324","MYSTRALLAKE:275:240:356:347","BOUGHSHADOW:146:200:856:151",
  "THEHOWLINGVALE:210:185:463:141","FELFIREHILL:245:255:713:344","NIGHTRUN:225:255:597:258",
  "WARSONGLUMBERCAMP:200:160:796:311","RAYNEWOODRETREAT:180:245:520:238",
  "FALLENSKYLAKE:235:205:547:426","SATYRNAAR:285:185:694:225",
},["Desolace"] = { "SHADOWPREYVILLAGE:230:230:167:389","THUNDERAXEFORTRESS:190:220:447:102",
  "ETHELRETHOR:205:250:311:61","GELKISVILLAGE:195:242:293:426","VALLEYOFSPEARS:245:285:212:215",
  "RANAZJARISLE:100:100:241:6","MAGRAMVILLAGE:205:285:590:365","MANNOROCCOVEN:285:280:399:380",
  "SARGERON:285:245:625:33","KOLKARVILLAGE:220:220:607:215","KORMEKSHUT:170:160:555:181",
  "SHADOWBREAKRAVINE:205:195:690:444","KODOGRAVEYARD:275:250:387:244",
  "NIJELSPOINT:200:250:554:0","TETHRISARAN:205:145:431:0",
},["BurningSteppes"] = { "DRACODAR:415:315:56:258","RUINSOFTHAURISSAN:270:285:513:99",
  "DREADMAULROCK:220:225:707:168","MORGANSVIGIL:294:270:708:311","ALTAROFSTORMS:225:220:36:109",
  "TERRORWINGPATH:280:355:722:46","BLACKROCKPASS:270:310:589:279","PILLAROFASH:320:270:377:285",
  "BLACKROCKSTRONGHOLD:245:265:334:114","BLACKROCKMOUNTAIN:256:280:173:101",
},["BlastedLands"] = { "DREADMAULPOST:245:195:361:195","THETAINTEDSCAR:384:450:212:178",
  "DREADMAULHOLD:195:180:361:15","GARRISONARMORY:170:200:472:9","ALTAROFSTORMS:185:155:310:133",
  "SERPENTSCOIL:225:170:501:140","DARKPORTAL:265:220:453:259","NETHERGARDEKEEP:185:190:559:30",
  "RISEOFTHEDEFILER:170:145:405:123",
},["Aszhara"] = { "SHADOWSONGSHRINE:225:180:35:422","TIMBERMAWHOLD:235:270:250:106",
  "BAYOFSTORMS:270:300:479:201","THESHATTEREDSTRAND:160:210:404:194","JAGGEDREEF:570:170:366:0",
  "BITTERREACHES:245:185:644:40","TOWEROFELDARA:120:155:818:107","FORLORNRIDGE:220:255:191:369",
  "TEMPLEOFARKKORAN:190:200:681:153","LEGASHENCAMPMENT:235:140:478:44","URSOLAN:145:215:422:95",
  "RUINSOFELDARATH:265:280:238:221","SOUTHRIDGEBEACH:370:220:389:353","VALORMOK:215:175:84:229",
  "THALASSIANBASECAMP:240:155:499:119","RAVENCRESTMONUMENT:240:125:552:499",
  "HALDARRENCAMPMENT:200:150:77:331","THERUINEDREACHES:395:128:396:540",
  "LAKEMENNAR:315:200:296:429",
},["Felwood"] = { "RUINSOFCONSTELLAS:235:155:297:381","EMERALDSANCTUARY:185:160:405:429",
  "FELPAWVILLAGE:240:145:483:0","TALONBRANCHGLADE:160:145:548:90","MORLOSARAN:145:159:496:509",
  "JADEFIRERUN:195:170:330:29","SHATTERSCARVALE:235:200:307:123","JAEDENAR:245:128:271:331",
  "BLOODVENOMFALLS:235:145:292:263","DEADWOODVILLAGE:175:135:408:533",
  "JADEFIREGLEN:165:155:332:465","IRONTREEWOODS:215:215:420:54",
},["EasternPlaguelands"] = { "THENOXIOUSGLADE:225:215:722:166",
  "QUELLITHIENLODGE:230:150:422:36","NORTHPASSTOWER:240:195:457:109","TERRORDALE:190:205:79:98",
  "BLACKWOODLAKE:230:235:442:199","EASTWALLTOWER:180:160:592:241","DARROWSHIRE:210:179:309:489",
  "CORINSCROSSING:165:160:537:367","THEMARRISSTEAD:200:205:156:360","NORTHDALE:190:205:620:128",
  "PLAGUEWOOD:360:270:169:83","LAKEMERELDAR:250:175:537:463","THEINFECTISSCAR:195:275:620:291",
  "PESTILENTSCAR:205:250:409:345","ZULMASHAR:205:165:614:30","CROWNGUARDTOWER:205:165:291:401",
  "THONDRORILRIVER:220:360:7:231","LIGHTSHOPECHAPEL:175:245:716:299","TYRSHAND:245:170:717:471",
  "STRATHOLME:240:200:194:9","THEFUNGALVALE:210:210:271:261","THEUNDERCROFT:185:150:172:477",
},["StonetalonMountains"] = { "BOULDERSLIDERAVINE:145:107:572:561",
  "WEBWINDERPATH:288:355:457:282","MIRKFALLONLAKE:200:215:390:145","CAMPAPARAJE:190:97:718:571",
  "SISHIRCANYON:125:125:475:433","STONETALONPEAK:270:205:247:0","GRIMTOTEMPOST:225:120:668:515",
  "MALAKAJIN:125:86:663:582","WINDSHEARCRAG:320:275:553:197","THECHARREDVALE:230:355:210:234",
  "SUNROCKRETREAT:150:150:389:320",
},["WesternPlaguelands"] = { "DARROWMERELAKE:370:270:504:343","RUINSOFANDORHOL:285:230:260:355",
  "THEBULWARK:225:185:137:293","FELSTONEFIELD:160:125:300:311","THEWEEPINGCAVE:160:200:566:198",
  "CAERDARROW:170:165:600:412","SORROWHILL:300:206:355:462","GAHRRONSWITHERING:180:205:520:250",
  "HEARTHGLEN:340:288:307:16","DALSONSTEARS:220:150:381:265","THEWRITHINGHAUNT:170:190:451:323",
  "NORTHRIDGELUMBERCAMP:220:180:382:164","THONDRORILRIVER:205:340:590:86",
},["Feralas"] = { "THEFORGOTTENCOAST:145:320:404:256","FRAYFEATHERHIGHLANDS:110:170:478:386",
  "RUINSOFRAVENWIND:190:155:305:0","THETWINCOLOSSALS:285:245:319:75","DREAMBOUGH:150:125:454:0",
  "GORDUNNIOUTPOST:140:165:690:141","ISLEOFDREAD:215:293:192:375","LOWERWILDS:225:180:751:198",
  "FERALSCARVALE:115:115:486:329","RUINSOFISILDIEN:190:250:540:320","ONEIROS:110:110:493:70",
  "DIREMAUL:230:195:454:201","SARDORISLE:180:180:208:234","CAMPMOJACHE:155:160:689:233",
  "THEWRITHINGDEEP:240:220:618:298","GRIMTOTEMCOMPOUND:120:195:623:167",
},["Winterspring"] = { "WINTERFALLVILLAGE:145:125:617:158","ICETHISTLEHILLS:125:165:611:242",
  "LAKEKELTHERIL:215:185:401:198","STARFALLVILLAGE:185:160:392:137","EVERLOOK:165:200:509:107",
  "FROSTFIREHOTSPRINGS:240:140:222:172","FROSTWHISPERGORGE:200:160:523:376",
  "THEHIDDENGROVE:175:185:555:27","DARKWHISPERGORGE:255:205:447:441",
  "FROSTSABERROCK:250:180:368:7","OWLWINGTHICKET:165:140:593:340",
  "TIMBERMAWPOST:230:120:229:243","MAZTHORIL:185:180:493:258",
},["Silithus"] = { "THESCARABWALL:288:256:116:413",
  "THECRYSTALVALE:320:289:104:24","HIVEASHI:512:320:265:12","SOUTHWINDVILLAGE:384:384:500:65",
  "TWILIGHTBASECAMP:320:256:344:197","HIVEZORA:384:512:97:144","HIVEREGAL:512:384:245:285",
},["DeadwindPass"] = { "THEVICE:270:270:426:299","KARAZHAN:300:245:269:337",
  "DEADMANSCROSSING:380:365:249:76",
},["AlteracValley"] = { "DUNBALDAR:270:240:348:13","ICEBLOODGARRISON:300:300:335:172",
  "FROSTWOLFKEEP:235:290:399:375",
},["Moonglade"] = { "LAKEELUNEARA:555:510:244:89", }}

local CLASS_COLORS = {
	["HUNTER"]  = { r = 0.67, g = 0.83, b = 0.45 , hex="|cffaad372" },
	["WARLOCK"] = { r = 0.58, g = 0.51, b = 0.79 , hex="|cff9382c9" },
	["PRIEST"]  = { r = 1.0,  g = 1.0,  b = 1.0 ,  hex="|cffffffff" },
	["PALADIN"] = { r = 0.96, g = 0.55, b = 0.73 , hex="|cfff48cba" },
	["MAGE"]    = { r = 0.41, g = 0.8,  b = 0.94 , hex="|cff68ccef" },
	["ROGUE"]   = { r = 1.0,  g = 0.96, b = 0.41 , hex="|cfffff468" },
	["DRUID"]   = { r = 1.0,  g = 0.49, b = 0.04 , hex="|cffff7c0a" },
	["SHAMAN"]  = { r = 0.96, g = 0.55, b = 0.73 , hex="|cfff48cba" },
	["WARRIOR"] = { r = 0.78, g = 0.61, b = 0.43 , hex="|cffc69b6d" }
	};


-- =============================================================================
-- misc. functions
-- =============================================================================


local function AoA_ChatMessage(text)
	AoAMod_ChatMessage("WorldMap", text);
end

local function AoA_ChatError(text)
	AoAMod_ChatError("WorldMap", text);
end

local function AoA_ChatWarning(text)
	AoAMod_ChatWarning("WorldMap", text);
end

local function AoA_ChatDebug(text)
	if (DEBUG_MODE) then AoAMod_ChatDebug("WorldMap", text); end
end


-- =============================================================================
-- ==  FullMapOverlayInfo handling
-- =============================================================================


local function oinfo_combine(prefix,tname,tw,th,ofx,ofy,mpx,mpy)
	-- shorten strings by replacing redundant prefix paths with a marker token
	local result = ":"..tw..":"..th..":"..ofx..":"..ofy;
	if (mpx~=0 or mpy~=0) then result = result..":"..mpx..":"..mpy; end
	if string.sub(tname, 0, string.len(prefix)) == prefix then
		return string.sub(tname, string.len(prefix)+1)..result
	end
	return "|"..result;
end


local function oinfo_uncombine(prefix,oinfo)
	local pfxUnused,tname,tw,th,ofx,ofy,mpx,mpy;
	_,_,pfxUnused,tname,tw,th,ofx,ofy = string.find(oinfo,
		"^([|]?)([^:]+):([^:]+):([^:]+):([^:]+):([^:]+)");
	if (not tname or not ofy) then return nil; end
	if (ofy) then
		_,_,mpx,mpy = string.find(oinfo,
			"^[|]?[^:]+:[^:]+:[^:]+:[^:]+:[^:]+:([^:]+):([^:]+)");
	end
	if (not mpy) then mpx=0; mpy=0; end
	if (pfxUnused~="|") then tname = prefix..tname; end
	return tname,tw+0,th+0,ofx+0,ofy+0,mpx+0,mpy+0;
end


local function oinfo_getname(prefix,oinfo)
	local junk1,junk2,pfxUnused,tname = string.find(oinfo, "^([|]?)([^:]+):");
	if (not tname) then return nil; end
	if (pfxUnused~="|") then tname = prefix..tname; end
	return tname;
end


local function getMainTable(mapFileName)
	local t = FullMapOverlayInfo[mapFileName];
	if (not t) then t = { }; FullMapOverlayInfo[mapFileName] = t; end
	return t;
end


local function getErrataTable(mapFileName)
	local t = AoAData.WorldMap.FWM_Errata[mapFileName];
	if (not t) then t = { }; AoAData.WorldMap.FWM_Errata[mapFileName] = t; end
	return t;
end


function AoAWMap_FWMInit()
	-- Integrate the contents of the errata table into the main dataset.
	-- and while we're at it, remove anything we don't recognize from the errata table!
	
	local mapFileName, errataTable, i, oinfo;
	for mapFileName,errataTable in next,AoAData.WorldMap.FWM_Errata do
		-- hack to keep strings short and maintainable.
		local prefix = "Interface\\WorldMap\\"..mapFileName.."\\";
		
		-- build a temporary index of the mainTable, from textureName to index!
		local mainIndex = {};
		local mainTable = getMainTable(mapFileName);
		for i,oinfo in next,mainTable do
			local tname = oinfo_uncombine(prefix,oinfo);
			if (tname) then mainIndex[tname] = i; end
		end
		
		-- build a temporary index of the errata too (removing redundant entries).
		local errataIndex = {};
		for i,oinfo in next,errataTable do
			local tname = oinfo_uncombine(prefix,oinfo);
			if (not tname) then
				AoA_ChatDebug(mapFileName..": borked: "..oinfo);
				errataTable[i] = nil
			else
				if errataIndex[tname] then
					AoA_ChatDebug(mapFileName..": redundant: "..errataTable[errataIndex[tname]]);
					errataTable[errataIndex[tname]] = nil;
				end
				errataIndex[tname] = i;
			end
		end
		
		-- now integrate errata into mainTable (for this session only)
		for i,oinfo in next,errataTable do
			local tname = oinfo_uncombine(prefix,oinfo);
			if mainIndex[tname] then
				if (mainTable[mainIndex[tname]] ~= oinfo) then
					AoA_ChatDebug(mapFileName..": update "..oinfo);
					mainTable[mainIndex[tname]] = oinfo;
				else
					AoA_ChatDebug(mapFileName..": redundant: "..oinfo);
					errataTable[i] = nil;
				end
			else
				AoA_ChatDebug(mapFileName..": add "..oinfo);
				table.insert(mainTable, oinfo);
			end
		end
	end
end


-- =============================================================================
-- ==  WorldMap Frame
-- =============================================================================


--------------------------------------------------------------------------------
-- Toggle the WorldMap frame
--------------------------------------------------------------------------------
function AoAWMap_Toggle()
	AoA_Toggle(AoAWMap_TabID);
end


--------------------------------------------------------------------------------
-- OnLoad
--------------------------------------------------------------------------------
function AoAWMap_OnLoad()

	-- Register for the following events
	this:RegisterEvent("ADDON_LOADED");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("PLAYER_LEAVING_WORLD");
	
	-- init texture tiles
	for i=1, WORLDMAP_DETAIL_TILES, 1 do
		getglobal("AoAWorldMapDetailTile"..i):SetHeight(WORLDMAP_DETAIL_TEXTURE_SIZE);
		getglobal("AoAWorldMapDetailTile"..i):SetWidth(WORLDMAP_DETAIL_TEXTURE_SIZE);
	end
	
end

function AoAWMap_RegisterEvents()
	this:RegisterEvent("WORLD_MAP_UPDATE");
	this:RegisterEvent("ZONE_CHANGED_NEW_AREA");
end

function AoAWMap_UnregisterEvents()
	this:UnregisterEvent("WORLD_MAP_UPDATE");
	this:UnregisterEvent("ZONE_CHANGED_NEW_AREA");
end


--------------------------------------------------------------------------------
-- Initializes everything relating to saved variables and data in other lua files
-- This should be called ONLY when we're sure that all other files have been loaded
--------------------------------------------------------------------------------
function AoAWMap_Init()
	
	-- init module
	info = {
		frame = AoAWorldMapFrame;
		init  = AoAWMap_InitModule;
		text  = AOA_WORLDMAP_TABTEXT;
		addon = "AoA_WorldMap";
		};
	AoAWMap_TabID = AoA_RegisterModule(info);
	
	-- AddOn is initialized now
	AoAWMap_Initialized = true;
	AoA_ChatMessage(string.format(AOA_LOADED, GetAddOnMetadata("AoA_WorldMap", "Version")));
	
end


--------------------------------------------------------------------------------
-- Initializes the module
-- called by the core addon
--------------------------------------------------------------------------------
function AoAWMap_InitModule()
	
	-- setup the saved variables if needed
	AoAWMap_InitSavedVars();
	
	-- init FWM
	AoAWMap_FWMInit();
	
end


--------------------------------------------------------------------------------
-- Create all the necessary saved variables if they don't exist
-- The default settings for all saved variables are stored here
--------------------------------------------------------------------------------
function AoAWMap_InitSavedVars()
	
	--
	-- global data
	--
	
	-- make shure that the saved settings are up to date
	if(AoAData.WorldMap == nil or tonumber(AoAData.WorldMap.Version) < AOAWMAP_DATA_COMPATIBILITY) then
		AoAData.WorldMap = {};
		AoAData.WorldMap.Version = AOAWMAP_DATA_VERSION;
		AoA_ChatWarning(AOA_DATA_UPDATED);
	end
	
	-- FWM OverlayErrata
	if(AoAData.WorldMap.FWM_Errata == nil) then
		AoAData.WorldMap.FWM_Errata = { };
	end
	
	--
	-- char data
	--
	
	-- make shure that the saved settings are up to date
	if(AoACharData.WorldMap == nil or tonumber(AoACharData.WorldMap.Version) < AOAWMAP_DATA_COMPATIBILITY) then
		AoACharData.WorldMap = {};
		AoACharData.WorldMap.Version = AOAWMAP_DATA_VERSION;
		AoA_ChatWarning(AOA_CHARDATA_UPDATED);
	end
	
	-- map follows player
	-- value: true/false
	if(AoACharData.WorldMap.FollowPlayer == nil) then
		AoACharData.WorldMap.FollowPlayer = true;
	end
	
	-- FWM color
	if(not AoACharData.WorldMap.FWM_ColorStyle) then
		AoACharData.WorldMap.FWM_ColorStyle = 2
	end
	
	-- FWM transparency
	if(not AoACharData.WorldMap.FWM_Transparency) then
		AoACharData.WorldMap.FWM_Transparency = 1.0
	end
AoACharData.WorldMap.FWM_Enabled = true;
	
end


--------------------------------------------------------------------------------
-- OnEvent
--------------------------------------------------------------------------------
function AoAWMap_OnEvent()

	if ( event == "ADDON_LOADED" and arg1 == "AoA_WorldMap") then
		AoAWMap_ADDON_LOADED = true;
	elseif ( event == "VARIABLES_LOADED" ) then
		AoAWMap_VARIABLES_LOADED = true;
	elseif ( event == "PLAYER_ENTERING_WORLD" ) then
		AoAWMap_RegisterEvents();
	elseif ( event == "PLAYER_LEAVING_WORLD" ) then
		AoAWMap_UnregisterEvents();
	end
	
	-- Once these two events have fired we can assume that all other files have been loaded
	-- It's now safe to initialize AtlasEnhanced if it hasn't already been done
	if ( AoAWMap_ADDON_LOADED and AoAWMap_VARIABLES_LOADED and AoAWMap_Initialized == false ) then
		AoAWMap_Init();
	end
	
	if(event == "ZONE_CHANGED_NEW_AREA") and (AoACharData.WorldMap.FollowPlayer == true) then
		-- set map to the current player position
		-- and update the map
		SetMapToCurrentZone();
		local continent = GetCurrentMapContinent();
		local zone = GetCurrentMapZone();
		if continent then
			SetMapZoom(continent, zone);
		else
			SetMapZoom(0);
		end
		AoAWMap_WorldMapUpdate();
		
	elseif(event == "WORLD_MAP_UPDATE") then
		-- simple map update
		AoAWMap_WorldMapUpdate();
		
	end
	
end


--------------------------------------------------------------------------------
-- Event: OnShow
--------------------------------------------------------------------------------
function AoAWMap_OnShow()
	if(AoACharData.WorldMap.FollowPlayer == true) then
		SetMapToCurrentZone();
	end
	AoAWMap_WorldMapUpdate();
end


--------------------------------------------------------------------------------
-- Event: OnHide
--------------------------------------------------------------------------------
function AoAWMap_OnHide()
end


--------------------------------------------------------------------------------
-- Update the map textures, overlays, pois
--------------------------------------------------------------------------------
function AoAWMap_WorldMapUpdate()

	-- Setup the MapTexture
	local mapFileName, textureHeight = GetMapInfo();
	if ( not mapFileName ) then
		mapFileName = "World";
	end
	for i=1, WORLDMAP_DETAIL_TILES, 1 do
		getglobal("AoAWorldMapDetailTile"..i):SetTexture("Interface\\WorldMap\\"..mapFileName.."\\"..mapFileName..i);
	end
	
	-- get scale factor
	local scale = 1 / AoAWorldMapFrame:GetEffectiveScale();

	-- Setup the POI's
	local numPOIs = GetNumMapLandmarks();
	local name, description, textureIndex, x, y;
	local worldMapPOI;
	local x1, x2, y1, y2;

	if ( WORLDMAP_POIS < numPOIs ) then
		for i=WORLDMAP_POIS+1, numPOIs do
			AoAWMap_CreatePOI(i);
		end
		WORLDMAP_POIS = numPOIs;
	end
	for i=1, WORLDMAP_POIS do
		worldMapPOI = getglobal("AoAWorldMapPOI"..i);
		if ( i <= numPOIs ) then
			name, description, textureIndex, x, y = GetMapLandmarkInfo(i);
			x1, x2, y1, y2 = AoAWMap_GetPOITextureCoords(textureIndex);
			getglobal(worldMapPOI:GetName().."Texture"):SetTexCoord(x1, x2, y1, y2);
			x = x * AoAWorldMapButton:GetWidth() * scale;
			y = -y * AoAWorldMapButton:GetHeight() * scale;
			worldMapPOI:SetPoint("CENTER", "AoAWorldMapButton", "TOPLEFT", x, y );
			worldMapPOI.name = name;
			worldMapPOI.description = description;
			worldMapPOI:Show();
		else
			worldMapPOI:Hide();
		end
	end
	
	-- Setup the overlays
	AoAWMap_WorldMapUpdateOverlays();

end


function AoAWMap_WorldMapUpdateOverlays()
	local mapOverLay;
	dtlFrame = "WorldMapDetailFrame";
	mapOverLay = "AoAWorldMapOverlay";
	
	local mapFileName, textureHeight = GetMapInfo();
	if (not mapFileName) then mapFileName = "World"; end
	
	-- hack to keep strings short and maintainable
	local prefix = "Interface\\WorldMap\\"..mapFileName.."\\";
	
	-- (1) create oinfos for discovered areas in this zone
	local i, tname, oinfo;
	local discovered = {};
	local numOverlays = GetNumMapOverlays();
	for i=1, numOverlays do
		local tname,tw,th,ofx,ofy,mpx,mpy = GetMapOverlayInfo(i);
		discovered[tname] = oinfo_combine(prefix,tname,tw,th,ofx,ofy,mpx,mpy);
	end
	
	-- (2) update any overlays for which our stored data is *incorrect* (should never happen!)
	local zoneTable = getMainTable(mapFileName);
	numOverlays = getn(zoneTable);
	for i,oinfo in next,zoneTable do
		local tname = oinfo_getname(prefix,oinfo);
		if discovered[tname] then
			if discovered[tname] == 1 then
				AoA_ChatDebug(mapFileName..": repeating "..tname.." ??");
			elseif discovered[tname] ~= oinfo then
				AoA_ChatDebug(mapFileName..": update "..discovered[tname]);
				zoneTable[i] = discovered[tname];
				-- record in the errata table for next time!
				table.insert(getErrataTable(mapFileName),discovered[tname]);
			end
			discovered[tname] = 1;
		end
	end
	
	-- (3) add any overlays which are *missing* from our stored data (should never happen!)
	for tname,oinfo in next,discovered do
		if oinfo ~= 1 then
			AoA_ChatDebug(mapFileName..": adding "..oinfo);
			table.insert(zoneTable,oinfo);
			-- record in the errata table for next time!
			table.insert(getErrataTable(mapFileName),oinfo);
		end
	end
	
	-- Modified version of original overlay stuff
	local textureName, textureWidth, textureHeight, offsetX, offsetY, mapPointX, mapPointY;
	local textureCount = 0, neededTextures;
	local texture;
	local texturePixelWidth, textureFileWidth, texturePixelHeight, textureFileHeight;
	local numTexturesWide, numTexturesTall;
	
	for i,oinfo in next,zoneTable do
		textureName, textureWidth, textureHeight, offsetX, offsetY, mapPointX, mapPointY = oinfo_uncombine(prefix,oinfo);
		
		if AoACharData.WorldMap.FWM_Enabled or discovered[textureName] then
			
			-- HACK: override *known incorrect* data with hard-coded fixes
			-- Otherwise it looks quite ugly when you toggle the faint areas on and off
			-- I am assuming here that strings are interned and comparisons are fast...hmm
			if (textureName == "Interface\\WorldMap\\Tirisfal\\BRIGHTWATERLAKE") then
				if (offsetX == 587) then offsetX = 584 end
			end
			if (textureName == "Interface\\WorldMap\\Silverpine\\BERENSPERIL") then
				if (offsetY == 417) then offsetY = 415 end
			end
			
			numTexturesWide = ceil(textureWidth/256);
			numTexturesTall = ceil(textureHeight/256);
			neededTextures = textureCount + (numTexturesWide * numTexturesTall);
			if ( neededTextures > WORLDMAP_OVERLAYS ) then
				for j=WORLDMAP_OVERLAYS+1, neededTextures do
--					AoA_ChatDebug("Creating texture for: "..textureName);
					AoAWorldMapFrame:CreateTexture("AoAWorldMapOverlay"..j, "ARTWORK");
				end
				WORLDMAP_OVERLAYS = neededTextures;
			end
			for j=1, numTexturesTall do
				if (j < numTexturesTall) then
					texturePixelHeight = 256; textureFileHeight = 256;
				else
					texturePixelHeight = mod(textureHeight, 256);
					if (texturePixelHeight == 0) then texturePixelHeight = 256; end
					textureFileHeight = 16;
					while(textureFileHeight < texturePixelHeight) do
						textureFileHeight = textureFileHeight * 2;
					end
				end
				for k=1, numTexturesWide do
					if (textureCount > WORLDMAP_OVERLAYS) then
						message("Too many worldmap overlays!"); return;
					end
--					AoA_ChatDebug("Calling GGWMO with textureCount "..textureCount+1);
					texture = getglobal( mapOverLay..(textureCount+1) );
					if (k < numTexturesWide) then
						texturePixelWidth = 256; textureFileWidth = 256;
					else
						texturePixelWidth = mod(textureWidth, 256);
						if (texturePixelWidth == 0) then texturePixelWidth = 256; end
						textureFileWidth = 16;
						while(textureFileWidth < texturePixelWidth) do
							textureFileWidth = textureFileWidth * 2;
						end
					end
					texture:SetWidth(texturePixelWidth * WORLDMAP_DETAIL_SCALE);
					texture:SetHeight(texturePixelHeight * WORLDMAP_DETAIL_SCALE);
					texture:SetTexCoord(0, texturePixelWidth/textureFileWidth, 0, texturePixelHeight/textureFileHeight);
					texture:ClearAllPoints();
					texture:SetPoint("TOPLEFT",
							offsetX*WORLDMAP_DETAIL_SCALE + (256*WORLDMAP_DETAIL_SCALE * (k-1)),
							-(offsetY*WORLDMAP_DETAIL_SCALE + (256*WORLDMAP_DETAIL_SCALE * (j - 1))));
					texture:SetTexture(textureName..(((j - 1) * numTexturesWide) + k));
					
					if discovered[textureName] then
						texture:SetVertexColor(1.0,1.0,1.0);
						texture:SetAlpha(1.0);
					else
						if(AoACharData.WorldMap.FWM_ColorStyle == 0) then
							texture:SetVertexColor(0.2,0.6,1.0);
						elseif(AoACharData.WorldMap.FWM_ColorStyle == 1) then
							texture:SetVertexColor(1.0,1.0,1.0);
						elseif(AoACharData.WorldMap.FWM_ColorStyle == 2) then
							texture:SetVertexColor(1.0,0.5,0.5);
						else
							message("Corrupt color selection detected, resetting to blue.")
							texture:SetVertexColor(0.2,0.6,1.0);
							AoACharData.WorldMap.FWM_ColorStyle = 0;
						end
						if(AoACharData.WorldMap.FWM_Transparency >= 0.0 and AoACharData.WorldMap.FWM_Transparency <= 1.0) then
							texture:SetAlpha(AoACharData.WorldMap.FWM_Transparency);
						else
							message("Corrupt transparency value detected, resetting to opaque.")
							AoACharData.WorldMap.FWM_Transparency = 1.0;
							texture:SetAlpha(AoACharData.WorldMap.FWM_Transparency);
						end
					end
					texture:Show();
					textureCount = textureCount + 1;
				end
			end
		end
	end
	-- hide unused overlays
	for i=textureCount+1, WORLDMAP_OVERLAYS do getglobal(mapOverLay..i):Hide(); end
end


--------------------------------------------------------------------------------
-- POI handling
--------------------------------------------------------------------------------


function AoAWMap_CreatePOI(index)
	local button = CreateFrame("Button", "AoAWorldMapPOI"..index, AoAWorldMapButton);
	button:SetWidth(32*WORLDMAP_DETAIL_SCALE);
	button:SetHeight(32*WORLDMAP_DETAIL_SCALE);
	button:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	button:SetScript("OnEnter", AoAWMapPOI_OnEnter);
	button:SetScript("OnLeave", AoAWMapPOI_OnLeave);
	button:SetScript("OnClick", AoAWMapPOI_OnClick);

	local texture = button:CreateTexture(button:GetName().."Texture", "BACKGROUND");
	texture:SetWidth(16*WORLDMAP_DETAIL_SCALE);
	texture:SetHeight(16*WORLDMAP_DETAIL_SCALE);
	texture:SetPoint("CENTER", 0, 0);
	texture:SetTexture("Interface\\Minimap\\POIIcons");
end


function AoAWMap_GetPOITextureCoords(index)
	local worldMapIconDimension = 16;
	local xCoord1, xCoord2, yCoord1, yCoord2; 
	local coordIncrement = worldMapIconDimension / WORLDMAP_POI_TEXTURE_WIDTH;
	xCoord1 = mod(index , WORLDMAP_POI_COLUMNS) * coordIncrement;
	xCoord2 = xCoord1 + coordIncrement;
	yCoord1 = floor(index / WORLDMAP_POI_COLUMNS) * coordIncrement;
	yCoord2 = yCoord1 + coordIncrement;
	return xCoord1, xCoord2, yCoord1, yCoord2;
end


function AoAWMapPOI_OnEnter()
	AoAWorldMapFrame.poiHighlight = 1;
	if ( this.description and strlen(this.description) > 0 ) then
		AoAWorldMapFrameAreaLabel:SetText(this.name);
		AoAWorldMapFrameAreaDescription:SetText(this.description);
	else
		AoAWorldMapFrameAreaLabel:SetText(this.name);
		if(AOA_WORLDMAP_NOTES[this.name] ~= nil) then
			AoAWorldMapFrameAreaDescription:SetText(AOA_WORLDMAP_NOTES[this.name]);
		else
			AoAWorldMapFrameAreaDescription:SetText("");
		end
	end
end


function AoAWMapPOI_OnLeave()
	AoAWorldMapFrame.poiHighlight = nil;
	AoAWorldMapFrameAreaLabel:SetText(AoAWorldMapFrame.areaName);
	AoAWorldMapFrameAreaDescription:SetText("");
end


function AoAWMapPOI_OnClick()
	AoAWMapButton_OnClick(arg1, AoAWorldMapButton);
end


--------------------------------------------------------------------------------
-- WorldMapButton handling
--------------------------------------------------------------------------------


function AoAWMapButton_OnClick(mouseButton, button)
	local curCont = GetCurrentMapContinent();
	local curZone = GetCurrentMapZone();
	
	-- get scale factor
	local scale = 1 / AoAWorldMapFrame:GetEffectiveScale();
	
	if ( mouseButton == "LeftButton" ) then
		if ( not button ) then
			button = this;
		end
		local x, y = GetCursorPosition();
		x = x / button:GetEffectiveScale();
		y = y / button:GetEffectiveScale();

		local centerX, centerY = button:GetCenter();
		local width = button:GetWidth() * scale;
		local height = button:GetHeight() * scale;
		local adjustedY = (centerY + (height/2) - y) / height;
		local adjustedX = (x - (centerX - (width/2))) / width;
		ProcessMapClick( adjustedX, adjustedY);
	else
		if ( GetCurrentMapZone() ~= 0 ) then
			SetMapZoom(GetCurrentMapContinent());
		else
			SetMapZoom(0);
		end
	end
	if (curCont ~= GetCurrentMapContinent()) or (curZone ~= GetCurrentMapZone()) then
		PlaySound("igQuestLogOpen");
	end
end


function AoAWMapButton_OnUpdate(elapsed)
	
	-- get scale factor
	local scale = 1 / AoAWorldMapFrame:GetEffectiveScale();
	
	local x, y = GetCursorPosition();
	x = x / this:GetEffectiveScale();
	y = y / this:GetEffectiveScale();

	local centerX, centerY = this:GetCenter();
	local width = this:GetWidth() * scale;
	local height = this:GetHeight() * scale;
	local adjustedY = (centerY + (height/2) - y ) / height;
	local adjustedX = (x - (centerX - (width/2))) / width;
	local name, fileName, texPercentageX, texPercentageY, textureX, textureY, scrollChildX, scrollChildY = UpdateMapHighlight( adjustedX, adjustedY );
	
	-- silithus hack
	if fileName == "Silithus" then
		textureY = textureY * 2;
		texPercentageY = 1;
	end
	
	-- Area Label/Description
	AoAWorldMapFrame.areaName = name;
	if ( not AoAWorldMapFrame.poiHighlight ) then
		AoAWorldMapFrameAreaLabel:SetText(name);
		if(AOA_WORLDMAP_NOTES[name] ~= nil) then
			AoAWorldMapFrameAreaDescription:SetText(AOA_WORLDMAP_NOTES[name]);
		else
			AoAWorldMapFrameAreaDescription:SetText("");
		end
	end
	
	-- highlight
	if ( fileName ) then
		AoAWorldMapHighlight:SetTexCoord(0, texPercentageX, 0, texPercentageY);
		AoAWorldMapHighlight:SetTexture("Interface\\WorldMap\\"..fileName.."\\"..fileName.."Highlight");
		textureX = textureX * width;
		textureY = textureY * height;
		scrollChildX = scrollChildX * width;
		scrollChildY = -scrollChildY * height;
		if ( (textureX > 0) and (textureY > 0) ) then
			AoAWorldMapHighlight:SetWidth(textureX);
			AoAWorldMapHighlight:SetHeight(textureY);
			AoAWorldMapHighlight:SetPoint("TOPLEFT", "AoAWorldMapFrame", "TOPLEFT", scrollChildX, scrollChildY);
			AoAWorldMapHighlight:Show();
		end
	else
		AoAWorldMapHighlight:Hide();
	end
	
	-- Position player
	local playerX, playerY = GetPlayerMapPosition("player");
	if ( playerX == 0 and playerY == 0 ) then
		AoAWorldMapPlayer:Hide();
		AoAWorldMapPing:Hide();
	else
		playerX = playerX * AoAWorldMapFrame:GetWidth() * scale;
		playerY = -playerY * AoAWorldMapFrame:GetHeight() * scale;
		AoAWorldMapPlayer:Show();

		-- Position clear button to detect mouseovers
		AoAWorldMapPlayer:SetPoint("CENTER", "AoAWorldMapFrame", "TOPLEFT", playerX, playerY);
		
		-- Position player ping if its shown
		if ( AoAWorldMapPing:IsVisible() ) then
			AoAWorldMapPing:SetPoint("CENTER", "AoAWorldMapFrame", "TOPLEFT", playerX-7.7, playerY-8.2);
		else
			AoAWorldMapPing:SetAlpha(255);
			AoAWorldMapPing:Show();
			AoAWorldMapPing.timer = 1;
		end
	end
	
	-- Position group
	local partyX, partyY, partyMemberFrame;
	local playerCount = 0;
	if ( GetNumRaidMembers() > 0 ) then
		for i=1, MAX_PARTY_MEMBERS do
			partyMemberFrame = getglobal("AoAWorldMapParty"..i);
			partyMemberFrame:Hide();
		end
		for i=1, MAX_RAID_MEMBERS do
			local unit = "raid"..i;
			partyX, partyY = GetPlayerMapPosition(unit);
			partyMemberFrame = getglobal("AoAWorldMapRaid"..playerCount + 1);
			if ( (partyX ~= 0 or partyY ~= 0) and not UnitIsUnit(unit, "player") ) then
				partyX = partyX * AoAWorldMapFrame:GetWidth() * scale;
				partyY = -partyY * AoAWorldMapFrame:GetHeight() * scale;
				partyMemberFrame:SetPoint("CENTER", "AoAWorldMapFrame", "TOPLEFT", partyX, partyY);
				partyMemberFrame.name = nil;
				partyMemberFrame.unit = unit;
				partyMemberFrame:Show();
				playerCount = playerCount + 1;
			end
		end
	else
		for i=1, MAX_PARTY_MEMBERS do
			partyX, partyY = GetPlayerMapPosition("party"..i);
			partyMemberFrame = getglobal("AoAWorldMapParty"..i);
			if ( partyX == 0 and partyY == 0 ) then
				partyMemberFrame:Hide();
			else
				partyX = partyX * AoAWorldMapFrame:GetWidth() * scale;
				partyY = -partyY * AoAWorldMapFrame:GetHeight() * scale;
				partyMemberFrame:SetPoint("CENTER", "AoAWorldMapFrame", "TOPLEFT", partyX, partyY);
				partyMemberFrame:Show();
			end
		end
	end
	
	-- Position team
	local numTeamMembers = GetNumBattlefieldPositions();
	for i=playerCount+1, MAX_RAID_MEMBERS do
		partyX, partyY, name = GetBattlefieldPosition(i - playerCount);
		partyMemberFrame = getglobal("AoAWorldMapRaid"..i);
		if ( partyX == 0 and partyY == 0 ) then
			partyMemberFrame:Hide();
		else
			partyX = partyX * AoAWorldMapFrame:GetWidth() * scale;
			partyY = -partyY * AoAWorldMapFrame:GetHeight() * scale;
			partyMemberFrame:SetPoint("CENTER", "AoAWorldMapFrame", "TOPLEFT", partyX, partyY);
			partyMemberFrame.name = name;
			partyMemberFrame:Show();
		end
	end

	-- Position flags
	local flagX, flagY, flagToken, flagFrame, flagTexture;
	local numFlags = GetNumBattlefieldFlagPositions();
	for i=1, numFlags do
		flagX, flagY, flagToken = GetBattlefieldFlagPosition(i);
		flagFrame = getglobal("AoAWorldMapFlag"..i);
		flagTexture = getglobal("AoAWorldMapFlag"..i.."Texture");
		if ( flagX == 0 and flagY == 0 ) then
			flagFrame:Hide();
		else
			flagX = flagX * AoAWorldMapFrame:GetWidth() * scale;
			flagY = -flagY * AoAWorldMapFrame:GetHeight() * scale;
			flagFrame:SetPoint("CENTER", "AoAWorldMapFrame", "TOPLEFT", flagX, flagY);
			flagTexture:SetTexture("Interface\\WorldStateFrame\\"..flagToken);
			flagFrame:Show();
		end
	end
	for i=numFlags+1, WORLDMAP_FLAGS do
		flagFrame = getglobal("AoAWorldMapFlag"..i);
		flagFrame:Hide();
	end

	-- Position corpse
	local corpseX, corpseY = GetCorpseMapPosition();
	if ( corpseX == 0 and corpseY == 0 ) then
		AoAWorldMapCorpse:Hide();
	else
		corpseX = corpseX * AoAWorldMapFrame:GetWidth() * scale;
		corpseY = -corpseY * AoAWorldMapFrame:GetHeight() * scale;
		AoAWorldMapCorpse:SetPoint("CENTER", "AoAWorldMapFrame", "TOPLEFT", corpseX, corpseY);
		AoAWorldMapCorpse:Show();
	end
	
	-- Position FlightNode
--	if(AtlasEnhTaxi_GetNodeWMLoc) then
--		local flightnode = AtlasEnhTaxi_GetNodeWMLoc(GetCurrentMapContinent(), GetCurrentMapZone());
--		if(flightnode ~= nil) then
--			local taxiX = flightnode.x * AtlasEnhTabWorldMapInnerFrame:GetWidth() * scale;
--			local taxiY = -flightnode.y * AtlasEnhTabWorldMapInnerFrame:GetHeight() * scale;
--			AtlasEnhTabWorldMapTaxi:Show();
--			AtlasEnhTabWorldMapTaxi:SetPoint("CENTER", "AtlasEnhTabWorldMapInnerFrame", "TOPLEFT", taxiX, taxiY);
--		else
--			AtlasEnhTabWorldMapTaxi:Hide();
--		end
--	end
	
	-- if cursor is out of the frame hide labels
	if(not MouseIsOver(AoAWorldMapFrame) ) then
		AoAWorldMapFrameAreaLabel:SetText("");
		AoAWorldMapFrameAreaDescription:SetText("");
	end
	
	-- set position labes
	if(not MouseIsOver(AoAWorldMapFrame) ) then
		AoAWorldMapCursorPos:Hide();
	else
		local x, y = GetCursorPosition();
		x = x / this:GetEffectiveScale();
		y = y / this:GetEffectiveScale();
		local centerX, centerY = this:GetCenter();
		local width = this:GetWidth() * scale;
		local height = this:GetHeight() * scale;
		local adjustedY = (centerY + (height/2) - y ) / height;
		local adjustedX = (x - (centerX - (width/2))) / width;
		AoAWorldMapCursorPosText:SetText(floor(adjustedX*100)..", "..floor(adjustedY*100));
		AoAWorldMapCursorPos:Show();
	end
	playerX, playerY = GetPlayerMapPosition("player");
	if ( playerX == 0 and playerY == 0 ) then
		AoAWorldMapPlayerPos:Hide();
	else
		AoAWorldMapPlayerPosText:SetText(floor(playerX*100)..", "..floor(playerY*100));
		AoAWorldMapPlayerPos:Show();
	end

end


function AoAWorldMapUnit_OnEnter()
	-- Adjust the tooltip based on which side the unit button is on
	local x, y = this:GetCenter();
	local parentX, parentY = this:GetParent():GetCenter();
	if ( x > parentX ) then
		GameTooltip:SetOwner(this, "ANCHOR_LEFT");
	else
		GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
	end
	
	-- See which POI's are in the same region and include their names in the tooltip
	local unitButton;
	local newLineString = "";
	local tooltipText = "";
	local class, color;
	
	-- Check player
	if ( MouseIsOver(AoAWorldMapPlayer) ) then
		_, class = UnitClass("player");
		color = CLASS_COLORS[class];
		tooltipText = UnitLevel("player").." "..color.hex..UnitName("player").."|r";
		newLineString = "\n";
	end
	
	-- Check party
	for i=1, MAX_PARTY_MEMBERS do
		unitButton = getglobal("AoAWorldMapParty"..i);
		if ( unitButton:IsVisible() and MouseIsOver(unitButton) ) then
			_, class = UnitClass("party"..i);
			color = CLASS_COLORS[class];
			tooltipText = tooltipText..newLineString..UnitLevel("party"..i).." "..color.hex..UnitName("party"..i).."|r";
			newLineString = "\n";
		end
	end
	
	--Check Raid
	for i=1, MAX_RAID_MEMBERS do
		unitButton = getglobal("AoAWorldMapRaid"..i);
		if ( unitButton:IsVisible() and MouseIsOver(unitButton) ) then
			_, class = UnitClass("raid"..i);
			color = CLASS_COLORS[class];
			tooltipText = tooltipText..newLineString..UnitLevel("raid"..i).." "..color.hex..UnitName("raid"..i).."|r";		
			newLineString = "\n";
		end
	end
	
	GameTooltip:SetText(tooltipText);
	GameTooltip:Show();
end


--------------------------------------------------------------------------------
-- Continent/Zone DropDowns
--------------------------------------------------------------------------------


function AoAWMapContinentsDropDown_OnLoad()
	UIDropDownMenu_Initialize(this, AoAWMapContinentsDropDown_Initialize);
	UIDropDownMenu_SetWidth(130);
end


function AoAWMapContinentsDropDown_Initialize()
	AoAWMapFrame_LoadContinents(GetMapContinents());
end


function AoAWMapFrame_LoadContinents(...)
	local info;
	for i=1, arg.n, 1 do
		info = {};
		info.text = arg[i];
		info.func = AoAWMapContinentButton_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end


function AoAWMapZoneDropDown_OnLoad()
	this:RegisterEvent("WORLD_MAP_UPDATE");
	UIDropDownMenu_Initialize(this, AoAWMapZoneDropDown_Initialize);
	UIDropDownMenu_SetWidth(130);
end


function AoAWMapZoneDropDown_Initialize()
	AoAWMapFrame_LoadZones(GetMapZones(GetCurrentMapContinent()));
end


function AoAWMapFrame_LoadZones(...)
	local info;
	for i=1, arg.n, 1 do
		info = {};
		info.text = arg[i];
		info.func = AoAWMapZoneButton_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end


function AoAWMapContinentButton_OnClick()
	UIDropDownMenu_SetSelectedID(AoAWorldMapContinentDropDown, this:GetID());
	SetMapZoom(this:GetID());
end


function AoAWMapZoneButton_OnClick()
	UIDropDownMenu_SetSelectedID(AoAWorldMapZoneDropDown, this:GetID());
	SetMapZoom(GetCurrentMapContinent(), this:GetID());
end


function AoAWMap_UpdateZoneDropDownText()
	if ( GetCurrentMapZone() == 0 ) then
		UIDropDownMenu_ClearAll(AoAWorldMapZoneDropDown);
	else
		UIDropDownMenu_SetSelectedID(AoAWorldMapZoneDropDown, GetCurrentMapZone());
	end
end


function AoAWMap_UpdateContinentDropDownText()
	if ( GetCurrentMapContinent() == 0 ) then
		UIDropDownMenu_ClearAll(AoAWorldMapContinentDropDown);
	else
		UIDropDownMenu_SetSelectedID(AoAWorldMapContinentDropDown,GetCurrentMapContinent());
	end
end


--------------------------------------------------------------------------------
-- FollowButton handling
--------------------------------------------------------------------------------


function AoAWMapFollowButton_OnShow()
	if(AoACharData.WorldMap.FollowPlayer == true) then
		this:SetChecked(1);
	else
		this:SetChecked(0);
	end
end


function AoAWMapFollowButton_OnClick()
	if ( this:GetChecked() ) then
		AoACharData.WorldMap.FollowPlayer = true;
		PlaySound("igMainMenuOptionCheckBoxOn");
		SetMapToCurrentZone();
	else
		AoACharData.WorldMap.FollowPlayer = false;
		PlaySound("igMainMenuOptionCheckBoxOff");
	end
end
